﻿// Class1.cpp
#include "pch.h"
#include "Class1.h"
#include <collection.h>
#include <ppltasks.h>

using namespace CxxReadFileComponent;
using namespace Platform;
using namespace Platform::Collections;
using namespace Windows::Foundation;
using namespace Windows::Foundation::Collections;
using namespace Windows::Storage;
using namespace Windows::Storage::Streams;
using namespace concurrency;

ReadFile::ReadFile()
{
}

IAsyncAction^ ReadFile::ReadTxtFileAsync(String^ fileName)
{
    return create_async([this, fileName]{
        StorageFolder^ item = KnownFolders::DocumentsLibrary;
        task<StorageFile^> getFileTask(item->GetFileAsync(fileName));
        getFileTask.then([](StorageFile^ storageFile){
            task<IRandomAccessStream^> streamTask(storageFile->OpenAsync(FileAccessMode::Read));
            streamTask.then([](IRandomAccessStream^ istream){
                auto Reader = ref new DataReader(istream);
                task<UINT> bytesReadTask(Reader->LoadAsync(istream->Size));
                try
                {
                    UINT bytesRead = bytesReadTask.get();
                }
                catch(Exception^ ex)
                {
                    String^ result = ex->Message;
                }
            });	
        });
    });
}

//we will return a dummy progress on this operation for illustration purposes only
IAsyncActionWithProgress<double>^ ReadFile::ReadTxtFileWithProgressAsync(Platform::String^ fileName)
{
    return create_async([this, fileName](progress_reporter<double> reporter)
    {
        StorageFolder^ item = KnownFolders::DocumentsLibrary;
        task<StorageFile^> getFileTask(item->GetFileAsync(fileName));
        reporter.report(10.0);
        getFileTask.then([reporter](StorageFile^ storageFile)
        {
            task<IRandomAccessStream^> streamTask(storageFile->OpenAsync(FileAccessMode::Read));
            reporter.report(25.0);
            streamTask.then([reporter](IRandomAccessStream^ istream)
            {
                reporter.report(40.0);
                auto Reader = ref new DataReader(istream);
                task<UINT> bytesReadTask(Reader->LoadAsync(istream->Size));
                reporter.report(60.0);
                try
                {
                    UINT bytesRead = bytesReadTask.get();
                    reporter.report(100.0);				
                }
                catch(Exception^ ex)
                {
                    String^ result = ex->Message;
                }
            });	
        });
        reporter.report(100.0);
    });
}

task<UINT> ReadFile::ReadBytes(String^ fileName)
{
	StorageFolder^ item = KnownFolders::DocumentsLibrary;
    task<StorageFile^> getFileTask(item->GetFileAsync(fileName));
	return getFileTask.then([](StorageFile^ storageFile) 
	{
		task<IRandomAccessStream^> openTask(storageFile->OpenAsync(
        FileAccessMode::Read));
      return openTask.then([](IRandomAccessStream^ istream) 
	  {
        auto reader = ref new DataReader(istream);
         task<UINT> loadTask(reader->LoadAsync(istream->Size));
         return loadTask.then([reader](UINT bytesRead) 
		 {
			 return bytesRead;
		 });
	  });
	});
}

IAsyncOperation<int>^ ReadFile::GetByteCountAsync(Platform::String^ fileName)
{
	m_bytesRead = 0;
    return create_async([this, fileName]() -> int
    {		
		return ReadBytes(fileName).get();        
    });
}


task<UINT> ReadFile::ReadBytesWithProgress(Platform::String^ fileName, Concurrency::progress_reporter<double> progress)
{
	StorageFolder^ item = KnownFolders::DocumentsLibrary;
    task<StorageFile^> getFileTask(item->GetFileAsync(fileName));
	progress.report(10.0);
	return getFileTask.then([this, progress](StorageFile^ storageFile) 
	{
		progress.report(25.0);
		task<IRandomAccessStream^> openTask(storageFile->OpenAsync(
        FileAccessMode::Read));
      return openTask.then([this, progress](IRandomAccessStream^ istream) 
	  {
		  progress.report(40.0);
		  auto reader = ref new DataReader(istream);
	      task<UINT> loadTask(reader->LoadAsync(istream->Size));
		  progress.report(60.0);
		  return loadTask.then([reader, progress](UINT bytesRead) 
		  {
			  progress.report(100.0);
			  return bytesRead;
		  });
	  });
	});
}

IAsyncOperationWithProgress<int, double>^ ReadFile::GetByteCountWithProgressAsync(Platform::String^ fileName)
{
	m_bytesRead = 0;
    return create_async([this, fileName](progress_reporter<double> reporter) -> int 
    {
		return ReadBytesWithProgress(fileName, reporter).get();        
    });
}